{

rTrack macros engine
(c) 1999-2000 by raVen

01/06/00   + . ⥯  ॥ . ମ 뫨 -
             ॢᨭ ப  tStrPrs.ProcessString  tStrPrs.ProcessAsciiz.
             ॢᨭ 모 ७. த  ࠡ⠥ =)
21/06/00   + ᫥  ࠡ⠫ ⮫쪮  ⤥ . ᥩ த
              ଠ쭮;
           # ProcessString ⥯ ᯮ ProcessAsciiz;
21/07/00   +  楤 @Random  
23/07/00   # 몫祭 ஢ ᮢ

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
Unit rMacroz;
interface
Uses
 Objects;
{}
const
 PrsSet: Set of Char = ['|'];
type
{( tPrs )}
 pMacros = ^tMacros;
 tPrsProc = procedure(var s: String; const macros: pMacros);
 pPrs = ^tPrs;

 tPrs = object(tObject)
  ProcName: pString;
  PrsProc: tPrsProc;
  constructor Init(aName: String; aPrsProc: tPrsProc);
  destructor  Done; virtual;
  procedure   ProcessString(var s: String);
 end;
{( tStrPrs )}
 pStrPrs = ^tStrPrs;
 tStrPrs = object(tObject)
  PrsCol: pCollection;
  constructor Init;
  destructor  Done; virtual;
  procedure   AddPrs(aProcName: String; aPrs: tPrsProc);
  procedure   RemovePrs(aProcName: String);
  procedure   ProcessString(var s: String; const Macros: pMacros);
  procedure   ProcessAsciiz(var s: pChar; const Macros: pMacros);
 end;
{( tMacro )}
 pMacro = ^tMacro;
 tMacro = object(tObject)
  FindStr: pString;
  ReplStr: pString;
  CaseSens: Boolean;
  constructor Init(aFindStr,aReplStr: String; aCaseSens: Boolean);
  destructor  Done; virtual;
  procedure   ProcessString(var s: String; const Macros: pMacros);
  procedure   ProcessAsciiz(var s: pChar; const Macros: pMacros);
 end;
{( tMacroCollection )}
 pMacroCollection = ^tMacroCollection;
 tMacroCollection = object(tCollection)
  function Search(Key: Pointer; var Index: Integer): Boolean; virtual;
 end;
{( tMacros )}
 tMacros = object(tObject)
  MacroCol: pMacroCollection;
  sp: pStrPrs;
  DoFunc: Boolean;
  constructor Init;
  destructor  Done; virtual;
  procedure   AddStringMacro(aFindStr,aReplStr: String; aCaseSens: Boolean);
  procedure   RemoveMacro(aFindStr: String);
  procedure   AddNewPrs(aProcName: String; aPrs: tPrsProc);
  procedure   RemovePrs(aProcName: String);
  procedure   ProcessString(var s: String);
  procedure   ProcessAsciiz(var s: pChar);
 end;
{}
implementation
Uses rObjects, rStrings, rCommon, Strings, rAsciiz, Dos, rTime;
{( Standart Prs )}
procedure PrsPad(var s: String; const macros: pMacros);
 var
  s1,s2: String;
  c: Char;
  l: Integer;
 begin
 {left||10|@appname}
  s1:=UpStr(ExtractWord(1,s,PrsSet));
  s2:=ExtractWord(2,s,PrsSet);
  c:=s2[1];
  l:=CToN(ExtractWord(3,s,PrsSet));
  s2:=ExtractWord(4,s,PrsSet);
  if s1='LEFT' then if Length(s2)>l then s:=Copy(s2,Length(s2)-l+1,Length(s2)) else s:=LeftPadCh(s2,c,l) else
  if s1='RIGHT' then if Length(s2)>l then s:=Copy(s2,1,l) else s:=PadCh(s2,c,l) else
  if s1='CENTER' then if Length(s2)>l then s:=Copy(s2,(Length(s2)-l+1) div 2,l) else s:=CenterCh(s2,c,l)
  else s:=CenterCh(s2,c,l);
 end;
{}
procedure PrsNum(var s: String; const macros: pMacros);
 const
  legal: Set of Char = ['0'..'9'];
 var
  s1: String;
  x: Integer;
 begin
 {'|1234}
  s1:=ExtractWord(1,s,PrsSet);
  s:=ExtractWord(2,s,PrsSet);
  for x:=1 to Length(s) do if not (s[x] in legal) then exit;
  x:=Length(s)-2;
  while x>1 do
   begin
    NewInsert(s1[1],s,x);
    Dec(x,3);
   end;
 end;
{}
procedure PrsSize(var s: String; const macros: pMacros);
 const
  kbn: Longint = 1024;
  ss: Array[0..3] of pChar = ('b','Kb','Mb','Gb');
 var
  l,n: Longint;
  c: Byte;
 begin
 {2|2147483648}
  l:=CToN(ExtractWord(1,s,PrsSet));
  n:=CToN(ExtractWord(2,s,PrsSet));
  s:=NToC(n);
  c:=0;
  repeat
   n:=n div kbn;
   Inc(c);
   s:=NToC(n)+StrPas(ss[c]);
  until (abs(l-Length(s))<=1) or (n=0);
 end;
{}
procedure PrsFromDec(var s: String; const macros: pMacros);
 begin
 {nnumber|base}
  s:=FromDec(CToN(ExtractWord(1,s,PrsSet)),CToN(ExtractWord(2,s,PrsSet)),0);
 end;
{}
procedure PrsToDec(var s: String; const macros: pMacros);
 begin
 {nnumber|base}
  s:=NToC(ToDec(ExtractWord(1,s,PrsSet),CToN(ExtractWord(2,s,PrsSet))));
 end;
{}
procedure PrsUpStr(var s: String; const macros: pMacros);
 begin
 {string}
  s:=UpStr(s);
 end;
{}
procedure PrsLoStr(var s: String; const macros: pMacros);
 begin
 {string}
  s:=LoStr(s);
 end;
{}
procedure PrsRandom(var s: String; const macros: pMacros);
 var
  f: pStream;
  x,c: Longint;
 begin
 {filename}
  Randomize;
  if (not Exist(s)) then
   begin
    s:='['+s+'] is not found :-)';
    exit;
   end;

  if (Exist(ForceExtension(s,'sdx'))) then
   begin
    f:=New(pBufStream,Init(ForceExtension(s,'sdx'),stOpenRead or stDenyWrite,BlockSize div 8));
    with (f^) do
     begin
      Seek(Random(GetSize div SizeOf(Longint))*SizeOf(Longint));
      Read(x,SizeOf(x));
     end;
    DisposeObj(f);
    f:=New(pBufStream,Init(s,stOpenRead or stDenyWrite,BlockSize div 8));
    f^.Seek(x);
    StreamReadLn(f^,s);
    DisposeObj(f);
   end
  else
   begin
    f:=New(pBufStream,Init(s,stOpenRead or stDenyWrite,BlockSize));
    c:=0;
    repeat
     StreamReadLn(f^,s);
     Inc(c);
    until (f^.GetSize=f^.GetPos) or (f^.Status<>0);;
    c:=Random(c);
    f^.Seek(0);
    for x:=1 to c do StreamReadLn(f^,s);
    DisposeObj(f);
   end;
 end;
{( tPrs )}
constructor tPrs.Init;
 begin
  inherited Init;
  PrsProc:=aPrsProc;
  ProcName:=NewStr(aName);
 end;
{}
destructor  tPrs.Done;
 begin
  ReallocStr(ProcName,'');
  inherited Done;
 end;
{}
procedure   tPrs.ProcessString;
 var
  p: Pointer;
 begin
  p:=@Self;
  PrsProc(s,pMacros(p));
 end;
{( tStrPrs )}
constructor tStrPrs.Init;
 begin
  inherited Init;
  New(PrsCol,Init(16,16));
  AddPrs('@Pad',PrsPad);
  AddPrs('@Num',PrsNum);
  AddPrs('@Size',PrsSize);
  AddPrs('@FromDec',PrsFromDec);
  AddPrs('@ToDec',PrsToDec);
  AddPrs('@UpStr',PrsUpStr);
  AddPrs('@LoStr',PrsLoStr);
  AddPrs('@Random',PrsRandom);
 end;
{}
destructor tStrPrs.Done;
 begin
  DisposeObj(PrsCol);
  inherited Done;
 end;
{}
procedure tStrPrs.AddPrs;
 var
  x: Longint;
 begin
  if PrsCol^.Count>0 then for x:=0 to PrsCol^.Count-1 do
   if UpStr(GetPS(pPrs(PrsCol^.At(x))^.ProcName))=UpStr(aProcName) then
    with pPrs(PrsCol^.At(x))^ do
     begin
      PrsProc:=aPrs;
      exit;
     end;
  PrsCol^.Insert(New(pPrs,Init(aProcName,aPrs)));
 end;
{}
procedure tStrPrs.RemovePrs;
 var
  x: Longint;
 begin
  if PrsCol^.Count>0 then for x:=0 to PrsCol^.Count-1 do
  if UpStr(GetPS(pPrs(PrsCol^.At(x))^.ProcName))=UpStr(aProcName) then
  with PrsCol^ do
   begin
    AtFree(x);
    exit;
   end;
 end;
{}
procedure   tStrPrs.ProcessString;
 var
  p: pChar;
 begin
  if (s='') then exit;
  p:=PasStr(s);
  ProcessAsciiz(p,Macros);
  s:=StrPas(p);
  StrFree(p);
 end;
{}
procedure   tStrPrs.ProcessAsciiz;
 var
  s1,s2: String;
  tp,p1,p2,x1,x2: Longint;
  ta1,ta2,ta3: pChar;
  ll: Word;
  prs: pPrs;
 begin
  ta1:=nil;
  ta3:=nil;
  AscUpCase(s,ta3);
  p2:=0;
  while p2<>AscNotFound do
   begin
    AscUpCase(s,ta1);
    ll:=StrLen(ta1);
    p1:=0; p2:=AscNotFound;
    if PrsCol^.Count>0 then for x1:=0 to PrsCol^.Count-1 do
     begin
      s2:=GetPS(pPrs(PrsCol^.At(x1))^.ProcName)+'{';
      tp:=AscNotFound;
      p1:=AscNotFound;
      repeat
       if (tp=AscNotFound) then tp:=PosStrFrom(UpStr(s2),ta3,0) else tp:=PosStrFrom(UpStr(s2),ta3,tp+1);
       if (tp<>AscNotFound) then p1:=tp;
      until (tp=AscNotFound);
      if p1<>AscNotFound then p1:=p1+Length(s2);
      if (p2=AscNotFound) or ((p1>p2) and (p1<>AscNotFound)) then if (p1-Length(s2)-1<=ll) then
       begin
        if (ta1[p1-Length(s2)-1]<>Masyamba) then
         begin
          p2:=p1;
          x2:=x1;
        end
       else
        begin
         DeleteAsc(s,p1-Length(s2),1);
         DeleteAsc(ta1,p1-Length(s2),1);
         DeleteAsc(ta3,p1-Length(s2),1);
         ta3[p1-Length(s2)-1]:='!';
        end;
       end;
     end;
    p1:=p2;
    if (p1<>AscNotFound) then
     begin
      StrFree(ta1);
      ll:=StrLen(s);
      ta1:=CopyAsc(s,p1,ll);
      p2:=PosStr('}',ta1);
      ta2:=CopyAsc(ta1,0,p2);
      p2:=p1+p2;
      p1:=p1-Length(GetPS(pPrs(PrsCol^.At(x2))^.ProcName))-1;
      s1:=StrPas(ta2);
      StrFree(ta1);
      StrFree(ta2);
      DeleteAsc(s,p1,p2-p1+1);
      DeleteAsc(ta3,p1,p2-p1+1);
      prs:=pPrs(PrsCol^.At(x2));
      prs^.PrsProc(s1,Macros);

      InsertStr(s1,s,p1);
      InsertStr(s1,ta3,p1);
     end;
   end;
  StrFree(ta1);
  StrFree(ta3);
 end;
{( tMacro )}
constructor tMacro.Init;
 begin
  inherited Init;
  FindStr:=NewStr(aFindStr);
  ReplStr:=NewStr(aReplStr);
  CaseSens:=aCaseSens;
 end;
{}
destructor  tMacro.Done;
 begin
  ReallocStr(FindStr,'');
  ReallocStr(ReplStr,'');
  inherited Done;
 end;
{}
procedure   tMacro.ProcessString;
 var
  p: pChar;
 begin
  if (s='') then exit;
  p:=PasStr(s);
  ProcessAsciiz(p,Macros);
  s:=StrPas(p);
  StrFree(p);
 end;
{}
procedure   tMacro.ProcessAsciiz;
 var
  p,LastC,FromPos: Word;
  s1: pChar;
 begin
  if (s=nil) then exit;
  if (FindStr=nil) then exit;
  s1:=nil;
  LastC:=AscNotFound;
  if not CaseSens then AscUpCase(s,s1) else s1:=StrNew(s);
  repeat
   if (LastC<>AscNotFound) then FromPos:=LastC+Length(GetPS(ReplStr)) else FromPos:=0;
   p:=PosStrFrom(UpStr(GetPS(FindStr)),s1,FromPos);
   if p<>AscNotFound then
    begin
     if p>0 then if (s[p-1]=Masyamba) and (LastC<>p-1) then
      begin
       DeleteAsc(s,p-1,1);
       DeleteAsc(s1,p+2,1);
       continue;
      end;
     DeleteAsc(s,p,Length(GetPS(FindStr)));
     DeleteAsc(s1,p,Length(GetPS(FindStr)));
     InsertStr(GetPS(ReplStr),s,p);
     InsertStr(GetPS(ReplStr),s1,p);
     LastC:=p;
    end;
  until p=AscNotFound;
  StrFree(s1)
 end;
{( tMacroCollection )}
function    tMacroCollection.Search;
 var
  s: String;
  x: Integer;
 begin
  Search:=False;
  if (Key=nil) then exit;
  s:=UpStr(GetPS(pMacro(Key)^.FindStr));
  if (Count>0) then for x:=0 to Count-1 do if (s=UpStr(GetPS(pMacro(At(x))^.FindStr))) then
   begin
    Index:=x;
    Search:=True;
    exit;
   end;
 end;
{( tMacros )}
constructor tMacros.Init;
 var
  dt: DateTime;
 begin
  inherited Init;
  New(sp,Init);
  New(MacroCol,Init(16,16));
  DoFunc:=True;

  GetCurrentTime(dt);
  with (dt) do
   begin
    AddStringMacro('@cSec',NToC(Sec),false);
    AddStringMacro('@cMin',NToC(Min),false);
    AddStringMacro('@cHour',NToC(Hour),false);
    AddStringMacro('@cDay',NToC(Day),false);
    AddStringMacro('@cMonth',NToC(Month),false);
    AddStringMacro('@cYear',NToC(Year),false);
    AddStringMacro('@cTextMonth',MonthNameSE[Month],false);
   end;
 end;
{}
destructor  tMacros.Done;
 begin
  DisposeObj(MacroCol);
  DisposeObj(sp);
  inherited Done;
 end;
{}
procedure   tMacros.AddStringMacro;
 var
  x: Integer;
  m: pMacro;
 begin
  New(m,Init(aFindStr,aReplStr,aCaseSens));
  if MacroCol^.Search(m,x) then with pMacro(MacroCol^.At(x))^ do
   begin
    DisposeObj(m);
    ReallocStr(ReplStr,aReplStr);
    CaseSens:=aCaseSens;
    exit;
   end;
  DisposeObj(m);
  MacroCol^.Insert(New(pMacro,Init(aFindStr, aReplStr,aCaseSens)));
 end;
{}
procedure tMacros.RemoveMacro;
 var
  x: Longint;
 begin
  if MacroCol^.Count>0 then for x:=0 to MacroCol^.Count-1 do
   if UpStr(GetPS(pMacro(MacroCol^.At(x))^.FindStr))=UpStr(aFindStr) then
    begin
     MacroCol^.AtFree(x);
     exit;
    end;
 end;
{}
procedure   tMacros.AddNewPrs(aProcName: String; aPrs: tPrsProc);
 begin
  sp^.AddPrs(aProcName,aPrs);
 end;
{}
procedure tMacros.RemovePrs(aProcName: String);
 begin
  sp^.RemovePrs(aProcName);
 end;
{}
procedure   tMacros.ProcessString;
 var
  p: pChar;
 begin
  if (s='') then exit;
  p:=PasStr(s);
  ProcessAsciiz(p);
  s:=StrPas(p);
  StrFree(p);
 end;
{}
procedure   tMacros.ProcessAsciiz;
 var
  x: Integer;
  p: Pointer;
 begin
  if (s=nil) then exit;
  p:=@Self;
  for x:=0 to MacroCol^.Count-1 do pMacro(MacroCol^.At(x))^.ProcessAsciiz(s,pMacros(p));
  if DoFunc then sp^.ProcessAsciiz(s,pMacros(p));
 end;
{}
end.
